#include <stdio.h>
#include <stdlib.h>
#include <map>

#define ull unsigned long long

using namespace std;

int N,Q;
int A[100005],L,R,K;

map< pair<int,int>,int >m;

int main()
{
    scanf("%d%d",&N,&Q);

    for(int i=0;i<N;i++) scanf("%d",&A[i]);

    for(int i=0;i<N;i++)
    {
        m[make_pair(i,i)]=A[i];
        for(int j=i+1;j<N;j++) m[make_pair(i,j)]=m[make_pair(i,j-1)] & A[j];
    }
    for(int i=0;i<Q;i++){
     scanf("%d%d",&L,&R);
     printf("%d\n",m[make_pair(L-1,R-1)]);
    }

    return 0;
}
/*
5 4
1 5 4 3 2
1 3
4 5
2 5
2 3
*/